Index: /palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4108)
+++ /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4109)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! pass integer flag array as well as boundary flags to WS scalar advection 
+! routine
 ! 
 ! Former revisions:
@@ -248,5 +249,6 @@
 
     USE indices,                                                              &
-        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt,    &
+        ONLY:  advc_flags_s,                                                  &
+               nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt,    &
                wall_flags_0
 
@@ -2329,5 +2331,9 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_sca )  THEN
-                   CALL advec_s_ws( e, 'e' )
+                   CALL advec_s_ws( advc_flags_s, e, 'e',                      &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                                    bc_dirichlet_s  .OR.  bc_radiation_s )
                 ELSE
                    CALL advec_s_pw( e )
@@ -2443,5 +2449,9 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_sca )  THEN
-                   CALL advec_s_ws( diss, 'diss' )
+                   CALL advec_s_ws( advc_flags_s, diss, 'diss',                &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                                    bc_dirichlet_s  .OR.  bc_radiation_s )
                 ELSE
                    CALL advec_s_pw( diss )
@@ -2549,6 +2559,11 @@
            .AND.  .NOT. use_upstream_for_tke )  THEN
            IF ( ws_scheme_sca )  THEN
-               CALL advec_s_ws( i, j, e, 'e', flux_s_e, diss_s_e, &
-                                flux_l_e, diss_l_e , i_omp, tn )
+               CALL advec_s_ws( advc_flags_s,                                  &
+                                i, j, e, 'e', flux_s_e, diss_s_e,              &
+                                flux_l_e, diss_l_e , i_omp, tn,                &
+                                bc_dirichlet_l  .OR.  bc_radiation_l,          &
+                                bc_dirichlet_n  .OR.  bc_radiation_n,          &
+                                bc_dirichlet_r  .OR.  bc_radiation_r,          &
+                                bc_dirichlet_s  .OR.  bc_radiation_s )
            ELSE
                CALL advec_s_pw( i, j, e )
@@ -2618,6 +2633,11 @@
            .AND.  .NOT. use_upstream_for_tke )  THEN
            IF ( ws_scheme_sca )  THEN
-               CALL advec_s_ws( i, j, diss, 'diss', flux_s_diss, diss_s_diss,  &
-                                flux_l_diss, diss_l_diss, i_omp, tn )
+               CALL advec_s_ws( advc_flags_s,                                  &
+                                i, j, diss, 'diss', flux_s_diss, diss_s_diss,  &
+                                flux_l_diss, diss_l_diss, i_omp, tn,           &
+                                bc_dirichlet_l  .OR.  bc_radiation_l,          &
+                                bc_dirichlet_n  .OR.  bc_radiation_n,          &
+                                bc_dirichlet_r  .OR.  bc_radiation_r,          &
+                                bc_dirichlet_s  .OR.  bc_radiation_s )
            ELSE
                CALL advec_s_pw( i, j, diss )
@@ -3451,5 +3471,5 @@
        dvdy(k) =           ( v(k,j+1,i) - v(k,j,i)     ) * ddy
        dvdz(k) = 0.5_wp  * ( v(k+1,j,i) + v(k+1,j+1,i) -                 &
-                               v(k-1,j,i) - v(k-1,j+1,i) ) * dd2zu(k)
+                             v(k-1,j,i) - v(k-1,j+1,i) ) * dd2zu(k)
 
        dwdx(k) = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) -                 &
